module LibMHAFiltrable where
import qualified LibMHA as L

type FeedbackChopper = Either Int [Char]
type InputChopper    = (FeedbackChopper,())

splitFeedbackChopper :: Int -> FeedbackChopper
splitFeedbackChopper = Left
elemFeedbackChopper :: [Char] -> FeedbackChopper
elemFeedbackChopper = Right
splitInputChopper ::  Int -> InputChopper
splitInputChopper i = (Left i, ())
elemInputChopper :: [Char] -> InputChopper
elemInputChopper cs = (Right cs, ())

reflexMapChopDo :: FeedbackChopper -- ^ 入力系列を取ってfeedback途中かどうか判断し，途中でなければfeedbackと残りを返す
                -> InputChopper    -- ^ 入力途中かどうか判断アンド前処理．入力途中ならNothing, 入力が完了していれば，Just (前処理した奴)
                -> L.OutputChopper
                -> ((Char -> Char) -> String -> String -> String) -- ^ wktk (a.k.a. primitive conditioned reflex) x result from the feedbackmap (a.k.a. assoc memory) x input |-> output
                -> L.Retv           -- ^ current output. Nothing if a chopper detects something wrong.
reflexMapChopDo fch ich = L.reflexMapChopDo (fromFiltrableFCh fch) (fromFiltrableICh ich)

fromFiltrableFCh :: FeedbackChopper -> L.FeedbackChopper
fromFiltrableFCh (Left i)   = L.splitFeedbackChopper i
fromFiltrableFCh (Right cs) = L.elemFeedbackChopper cs
fromFiltrableICh :: InputChopper -> L.InputChopper
fromFiltrableICh (Left i,  ()) = L.splitInputChopper i
fromFiltrableICh (Right cs,()) = L.elemInputChopper cs

eqFeedbackChopper  :: Char -> FeedbackChopper
eqFeedbackChopper c = Right [c]
eqInputChopper     :: Char -> InputChopper
eqInputChopper    c = (Right [c], ())
