{-
build with:
skata@ipft410:~/src/Round1/lndired/trunk$ ghc --make ZMQMain.hs -package zeromq4-haskell -O -threaded -rtsopts
run with:
skata@ipft410:~/src/Round1/lndired/trunk$ python ~/src/Round1/src/run.py ./a.2.4.json -l learners.base.RemoteLearner --learner-cmd "./ZMQMain +RTS -N4 -RTS"
or
skata@ipft410:~/src/Round1/lndired/trunk$ python ~/src/Round1/src/run.py ./a.2.4.json -l learners.base.RemoteLearner --learner-cmd "./ZMQMain +RTS -N4 -RTS" -v ConsoleView
-}
{-# LANGUAGE CPP #-}

import System.ZMQ4
import Data.ByteString.Char8(pack, unpack, ByteString)
import System.Timeout -- I guess @setReceiveTimeout@ is not usable, at least with @receive@.
import Data.Char(isDigit)
import Data.Maybe(fromJust, isJust)
import qualified Data.IntMap as IM
import MagicHaskeller
import MagicHaskeller.CoreLang(primitiveToDynamic)
-- import MagicHaskeller.Minimal(simpleEF) -- simpleEF cannot be used when using data Retv. everyACE is used instead.

import System.Environment(getArgs)

import System.IO
import Debug.Trace

import Control.Concurrent.MVar

import MHAgent(Monitor(..), task, common, instinctDyn)

import System.Random

-- See http://zguide.zeromq.org/hs:interrupt
#if defined VERSION_unix || ! (defined mingw32_HOST_OS)
import System.Posix.Signals(installHandler, Handler(Catch), sigINT, sigTERM)

handler :: MVar Bool -> IO ()
handler mv =
    traceStack "MHAgent: Interrupted"
             modifyMVar_ mv (return . const True)
#endif

#ifdef ADDRESS
address = ADDRESS
#else
address = "localhost"
#endif

-- toriaezu ha kono kata de iku ga, baai ni yotte ha Conduit wo tsukau
mkMain :: RandomGen g =>
          Int -- ^ timeout in seconds
          -> g
          -> IO ()
mkMain timeo gen = withContext $ \cxt ->
  withSocket cxt Pair $ \sock -> do
            args <- getArgs
#ifdef PORT
            let port = PORT
#else
            let port = case args of pstr:_ | all isDigit pstr -> pstr
                                    _     -> "5556"
#endif
            connect sock $ "tcp://"++address++":" ++ port -- http://zguide.zeromq.org/hs:interrupt を見た感じbindが正しい気もするが，CommAI-envの例ではconnectを使っているので．
            mv <- newMVar False
#if defined VERSION_unix || ! (defined mingw32_HOST_OS)
            installHandler sigINT (Catch $ handler mv) Nothing
            installHandler sigTERM (Catch $ handler mv) Nothing
#endif
            let sender   = send sock [] . pack
                receiver = fmap unpack $ receiveTOfail (timeo * 1000000) sock
            -- setReceiveTimeout (restrict $ timeo * 1000) sock -- I guess this does not work when using @receive@.
            sender "hello"
            _r  <- receive sock
#ifdef MONITOR
            h <- openFile "interaction.txt" WriteMode
            hSetBuffering h LineBuffering
            task (Mon (Just h) Nothing) mv sender receiver 0 common instinctDyn gen 0 0 IM.empty []
#else
            task (Mon Nothing Nothing) mv sender receiver 0 common instinctDyn gen 0 0 IM.empty []
#endif


receiveTO timeo sock cont = do mbv <- System.Timeout.timeout timeo $ receive sock
                               case mbv of Nothing -> return ()
                                           Just v  -> cont v
receiveTOfail timeo sock  = do mbv <- System.Timeout.timeout timeo $ receive sock
                               case mbv of Nothing -> fail "receiveTOfail: Timeout."
                                           Just v  -> return v

main = mkMain 1 $ mkStdGen 124356987
